#ifndef FDQUEUE_H
#define FDQUEUE_H
#include "httpd.h"
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <sys/types.h>
#include <sys/socket.h>

/* Bleccch. 0 on success always rubbed me the wrong way */
/* All failures are unrecoverable */
#define FD_QUEUE_SUCCESS 0
#define FD_QUEUE_FAILURE -1 /* Needs to be an invalid file descriptor because
                               of queue_pop semantics */

typedef struct fd_queue_elem {
    int fd;
    struct sockaddr addr;
} FDQueueElement;

typedef struct fd_queue {
    int head;
    int tail;
    FDQueueElement *data;
    int bounds;
    int blanks;
    pthread_mutex_t one_big_mutex;
    pthread_cond_t not_empty;
    pthread_cond_t not_full;
} FDQueue;

int queue_init(FDQueue *queue, int queue_size, pool *a);
void *queue_destroy(FDQueue *queue);
int queue_push(FDQueue *queue, int fd, struct sockaddr *addr);
int queue_pop(FDQueue *queue, struct sockaddr *addr, int block_if_empty);
int queue_size(FDQueue *queue);
int increase_blanks(FDQueue *queue);
int queue_full(FDQueue *queue);
int block_on_queue(FDQueue *queue);

#endif /* FDQUEUE_H */
